#include "SoURLCompressedTexture2.h"
#define TEXT_QUALITY 14

SoURLCompressedTexture2::SoURLCompressedTexture2(char *url)
{

  Timer *dt = new Timer;
  
  node = new WebNode(url);
  if( ! node )
    {
      cerr << "SoURLCompressedTexture2: " << node->getErrMsg() << endl;
    }
  
  dt->stop("Compressed Texture loaded");
  
  unsigned char *buf = (unsigned char *)node->getBuffer();

  int dimx = 0, dimy = 0, i, j;

  dimx = buf[0]*256;
  dimx += buf[1];

  dimy = dimx;
  buf+=2;
  
  NewVector(data, 3*dimx*dimy, unsigned char);
  NewVector(revData, 3*dimx*dimy, unsigned char);
  wv_t *wv = new_wv(dimx);
  long streamLength = node->getBufSize()-2;
  
  if (dec_texr_wv(wv, buf, &streamLength, data, TEXT_QUALITY))
    info("Problems reported by wave-decompress!!!");

  info("Bytes used to this quality ", streamLength);
  
  delete_wv(&wv);
  
  //reverse the order of rows?
  for(i=0; i<dimx; i++)
    for(j=0; j<3*dimy; j++) 
      revData[i*dimx*3+j] = data[(dimx-i-1)*dimx*3+j];  
  
  //create the SoTexture2 node
  image.setValue(SbVec2s(dimx, dimy), 3, revData);

//   char name[256];
//   strcpy(name, "t");
//   URL *u = new URL(url);
//   strcat(name, u->getResourceName());
//   cerr << "writing to file : " << name << '\n';
//   FILE *f = fopen(name, "wb");
//   fprintf(f, "P6\n%d %d\n255\n", dimx, dimy);
//   fwrite(revData, dimx*dimy*3, 1, f);
//   fclose(f);
  delete data;
  delete node->getBuffer();
  delete node;
}

SoURLCompressedTexture2::~SoURLCompressedTexture2()
{
  delete revData;
}
